;
; application : Cruce - simple flat shading program
; compiler    : FASM
; system      : MenuetOS
; author      : macgub
; email       : macgub3@wp.pl
; Fell free to use this intro in your own distribution of MenuetOS.

; Some adjustments made by Madis Kalme
; madis.kalme@mail.ee
; I tried optimizing it a bit, but don't know if it was successful. The objects
; can be:
; 1) Read from a file (*.3DS standard)
; 2) Written in manually (at the end of the code)
SIZE_X equ 430
SIZE_Y equ 425
TIMEOUT equ 4
ROUND equ 10
NON   =   0
MMX   =   1

Ext   =   MMX			;Ext={ NON | MMX}

use32
	org    0x0
	db     'MENUET01'	; 8 byte id
	dd     0x01		; header version
	dd     START		; start of code
	dd     I_END		; size of image
	dd     I_END		; memory for app
	dd     I_END		; esp
	dd     0x0 , 0x0	; I_Param , I_Icon

START:	  ; start of execution
	cld
	;call read_from_file
	call draw_window

still:
	mov	eax,23		; wait here for event with timeout
	mov	ebx,TIMEOUT
;        cmp     [speed_flag],1
;        jne     .skip
;        mov     eax,11
    .skip:
	int	0x40

	cmp	eax,1		; redraw request ?
	je	red
	cmp	eax,2		; key in buffer ?
	je	key
	cmp	eax,3		; button in buffer ?
	je	button

	jmp	noclose

    red:			; redraw
	call	draw_window
	jmp	noclose

    key:			; key
	mov	eax,2		; just read it and ignore
	int	0x40
	jmp	noclose

    button:			; button
	mov	eax,17		; get id
	int	0x40

	cmp	ah,1		; button id=1 ?
	jne	noclose ;.ch_another

	mov	eax,-1		; close this program
	int	0x40
;      .ch_another:
;        cmp     ah,2
;        jne     .ch_another1
;        inc     [r_flag]
;        cmp     [r_flag],3
;        jne     noclose
;        mov     [r_flag],0
;      .ch_another1:
;        cmp     ah,3
;        jne     .ch_another2
;        inc     [dr_flag]
;        cmp     [dr_flag],2
;        jne     noclose
;        mov     [dr_flag],0
;      .ch_another2:
;        cmp     ah,4
;        jne     noclose
;        inc     [speed_flag]
;        cmp     [speed_flag],2
;        jne     noclose
;        mov     [speed_flag],0
    noclose:

	call	calculate_angle ; calculates sinus and cosinus
	call	copy_points
	call	rotate_points
	call	translate_points; translate from 3d to 2d
	call	clrscr		; clear the screen
	call	sort_triangles

    RDTSC
    push eax
	call	draw_triangles	; draw all triangles from the list

    RDTSC
    sub eax,[esp]
    sub eax,41
    mov     ecx,10
  .dc:
    xor     edx,edx
    mov     edi,10
    div     edi
    add     dl,30h
    mov     [STRdata+ecx-1],dl
    loop    .dc
    pop eax

	mov	eax,7		; put image
	mov	ebx,screen
	mov	ecx,SIZE_X shl 16 + SIZE_Y
	mov	edx,5 shl 16 + 20
	int	0x40

    mov  eax,4			   ; function 4 : write text to window
    mov  ebx,5*65536+23 	   ; [x start] *65536 + [y start]
    mov  ecx,-1
    mov  edx,STRdata		   ; pointer to text beginning
    mov  esi,10 		   ; text length
    int  40h

	jmp	still

    sort_triangles:
	mov	esi,triangles
	mov	edi,triangles_with_z
	mov	ebp,points_rotated

    make_triangle_with_z:	;makes list with triangles and z position
	movzx	eax,word[esi]
	lea	eax,[eax*3]
	movzx	ecx,word[ebp+eax*2+4]

	movzx	eax,word[esi+2]
	lea	eax,[eax*3]
	add	cx,word[ebp+eax*2+4]

	movzx	eax,word[esi+4]
	lea	eax,[eax*3]
	add	cx,word[ebp+eax*2+4]

	mov	ax,cx
	cwd
	idiv	word[i3]
	movsd			; store vertex coordinates
	movsw
	stosw			; middle vertex coordinate  'z' in triangles_with_z list
	cmp	dword[esi],-1
	jne	make_triangle_with_z
	movsd			; copy end mark
	mov	eax,4
	lea	edx,[edi-8-trizdd]
	mov	[high],edx
	call	quicksort
	mov	eax,4
	mov	edx,[high]
	call	insertsort
	jmp	end_sort

    quicksort:
	mov	ecx,edx
	sub	ecx,eax
	cmp	ecx,32
	jc	.exit
	lea	ecx,[eax+edx]
	shr	ecx,4
	lea	ecx,[ecx*8-4]; i
	mov	ebx,[trizdd+eax]; trizdd[l]
	mov	esi,[trizdd+ecx]; trizdd[i]
	mov	edi,[trizdd+edx]; trizdd[h]
	cmp	ebx,esi
	jg	@f		; direction NB! you need to negate these to invert the order
      if Ext=NON
	mov	[trizdd+eax],esi
	mov	[trizdd+ecx],ebx
	mov	ebx,[trizdd+eax-4]
	mov	esi,[trizdd+ecx-4]
	mov	[trizdd+eax-4],esi
	mov	[trizdd+ecx-4],ebx
	mov	ebx,[trizdd+eax]
	mov	esi,[trizdd+ecx]
      else
	movq	mm0,[trizdq+eax-4]
	movq	mm1,[trizdq+ecx-4]
	movq	[trizdq+ecx-4],mm0
	movq	[trizdq+eax-4],mm1
	xchg	ebx,esi
      end if
      @@:
	cmp	ebx,edi
	jg	@f		; direction
      if Ext=NON
	mov	[trizdd+eax],edi
	mov	[trizdd+edx],ebx
	mov	ebx,[trizdd+eax-4]
	mov	edi,[trizdd+edx-4]
	mov	[trizdd+eax-4],edi
	mov	[trizdd+edx-4],ebx
	mov	ebx,[trizdd+eax]
	mov	edi,[trizdd+edx]
      else
	movq	mm0,[trizdq+eax-4]
	movq	mm1,[trizdq+edx-4]
	movq	[trizdq+edx-4],mm0
	movq	[trizdq+eax-4],mm1
	xchg	ebx,edi
      end if
      @@:
	cmp	esi,edi
	jg	@f		; direction
      if Ext=NON
	mov	[trizdd+ecx],edi
	mov	[trizdd+edx],esi
	mov	esi,[trizdd+ecx-4]
	mov	edi,[trizdd+edx-4]
	mov	[trizdd+ecx-4],edi
	mov	[trizdd+edx-4],esi
      else
	movq	mm0,[trizdq+ecx-4]
	movq	mm1,[trizdq+edx-4]
	movq	[trizdq+edx-4],mm0
	movq	[trizdq+ecx-4],mm1
;        xchg    ebx,esi
      end if
      @@:
	mov	ebp,eax 	; direction
	add	ebp,8	   ;   j
      if Ext=NON
	mov	esi,[trizdd+ebp]
	mov	edi,[trizdd+ecx]
	mov	[trizdd+ebp],edi
	mov	[trizdd+ecx],esi
	mov	esi,[trizdd+ebp-4]
	mov	edi,[trizdd+ecx-4]
	mov	[trizdd+ecx-4],esi
	mov	[trizdd+ebp-4],edi
      else
	movq	mm0,[trizdq+ebp-4]
	movq	mm1,[trizdq+ecx-4]
	movq	[trizdq+ecx-4],mm0
	movq	[trizdq+ebp-4],mm1
      end if
	mov	ecx,edx    ;   i; direction
	mov	ebx,[trizdd+ebp]; trizdd[j]
      .loop:
	sub	ecx,8		; direction
	cmp	[trizdd+ecx],ebx
	jl	.loop		; direction
      @@:
	add	ebp,8		; direction
	cmp	[trizdd+ebp],ebx
	jg	@b		; direction
	cmp	ebp,ecx
	jge	@f		; direction
      if Ext=NON
	mov	esi,[trizdd+ecx]
	mov	edi,[trizdd+ebp]
	mov	[trizdd+ebp],esi
	mov	[trizdd+ecx],edi
	mov	edi,[trizdd+ecx-4]
	mov	esi,[trizdd+ebp-4]
	mov	[trizdd+ebp-4],edi
	mov	[trizdd+ecx-4],esi
      else
	movq	mm0,[trizdq+ecx-4]
	movq	mm1,[trizdq+ebp-4]
	movq	[trizdq+ebp-4],mm0
	movq	[trizdq+ecx-4],mm1
      end if
	jmp	.loop
      @@:
      if Ext=NON
	mov	esi,[trizdd+ecx]
	mov	edi,[trizdd+eax+8]
	mov	[trizdd+eax+8],esi
	mov	[trizdd+ecx],edi
	mov	edi,[trizdd+ecx-4]
	mov	esi,[trizdd+eax+4]
	mov	[trizdd+eax+4],edi
	mov	[trizdd+ecx-4],esi
      else
	movq	mm0,[trizdq+ecx-4]
	movq	mm1,[trizdq+eax+4]; dir
	movq	[trizdq+eax+4],mm0; dir
	movq	[trizdq+ecx-4],mm1
      end if
	add	ecx,8
	push	ecx edx
	mov	edx,ebp
	call	quicksort
	pop	edx eax
	call	quicksort
      .exit:
    ret
    insertsort:
	mov	esi,eax
      .start:
	add	esi,8
	cmp	esi,edx
	ja	.exit
	mov	ebx,[trizdd+esi]
      if Ext=NON
	mov	ecx,[trizdd+esi-4]
      else
	movq	mm1,[trizdq+esi-4]
      end if
	mov	edi,esi
      @@:
	cmp	edi,eax
	jna	@f
	cmp	[trizdd+edi-8],ebx
	jg	@f		   ; direction
      if Ext=NON
	mov	ebp,[trizdd+edi-8]
	mov	[trizdd+edi],ebp
	mov	ebp,[trizdd+edi-12]
	mov	[trizdd+edi-4],ebp
      else
	movq	mm0,[trizdq+edi-12]
	movq	[trizdq+edi-4],mm0
      end if
	sub	edi,8
	jmp	@b
      @@:
      if Ext=NON
	mov	[trizdd+edi],ebx
	mov	[trizdd+edi-4],ecx
      else
	movq	[trizdq+edi-4],mm1
      end if
	jmp	.start
      .exit:
    ret
end_sort:

 ; translate triangles_with_z to sorted_triangles
	mov	esi,triangles_with_z
	mov	edi,triangles
    again_copy:
      if Ext=NON
	movsd
	movsw
	add	esi,2
      else
	movq	mm0,[esi]
	movq	[edi],mm0
	add	esi,8
	add	edi,6
      end if
	cmp	dword[esi],-1
	jne	again_copy
;      if Ext=MMX
;        emms
;      end if
	movsd  ; copy end mark too
	ret

    clrscr:
	mov	edi,screen
	mov	ecx,SIZE_X*SIZE_Y*3/4
	xor	eax,eax
      if Ext=NON
	rep	stosd
      else
	pxor	mm0,mm0
      @@:
	movq	[edi+00],mm0
	movq	[edi+08],mm0
	movq	[edi+16],mm0
	movq	[edi+24],mm0
	add	edi,32
	sub	ecx,8
	jnc	@b
      end if
	ret

    calculate_angle:
	fninit
;        fldpi
;        fidiv   [i180]
	fld	[piD180]
	fimul	[angle_counter]
	fsincos
	fstp	[sinbeta]
	fstp	[cosbeta]
	inc	[angle_counter]
	cmp	[angle_counter],360
	jne	end_calc_angle
	mov	[angle_counter],0
    end_calc_angle:
	ret

    rotate_points:
	fninit
	mov	ebx,points_rotated
    again_r:
;        cmp     [r_flag],1
;        je      .z_rot
;        cmp     [r_flag],2
;        je      .x_rot
    .y_rot:
	mov	eax,[ebx+2]	;z
	mov	ax,word[ebx]	;x
	sub	eax,dword[xo]
	mov	dword[xsub],eax
	fld	[sinbeta]
	fimul	[zsub]
	fchs
	fld	[cosbeta]
	fimul	[xsub]
	faddp
	fiadd	[xo]
	fistp	word[ebx]  ;x
	fld	[sinbeta]
	fimul	[xsub]
	fld	[cosbeta]
	fimul	[zsub]
	faddp
	fiadd	[zo]
	fistp	word[ebx+4] ;z
;        jmp     .end_rot
;   .z_rot:
;        mov     ax,word[ebx]
;        sub     ax,word[xo]       ;need optimization
;        mov     [xsub],ax
;        mov     ax,word[ebx+2]
;        sub     ax,word[yo]
;        mov     [ysub],ax
;        fld     [sinbeta]
;        fimul   [ysub]
;        fld     [cosbeta]
;        fimul   [xsub]
;        faddp
;        fiadd   [xo]
;        fistp   word[ebx]
;        fld     [cosbeta]
;        fimul   [ysub]
;        fld     [sinbeta]
;        fimul   [xsub]
;        fchs
;        faddp
;        fiadd   [yo]
;        fistp   word[ebx+2]
;        jmp     .end_rot
;   .x_rot:
;        mov     ax,word[ebx+2]
;        sub     ax,[yo]
;        mov     [ysub],ax
;        mov     ax,word[ebx+4]
;        sub     ax,word[zo]
;        mov     [zsub],ax
;        fld     [sinbeta]
;        fimul   [zsub]
;        fld     [cosbeta]
;        fimul   [ysub]
;        faddp
;        fiadd   [yo]
;        fistp   word[ebx+2];y
;        fld     [cosbeta]
;        fimul   [zsub]
;        fld     [sinbeta]
;        fimul   [ysub]
;        fchs
;        faddp
;        fiadd   [zo]
;        fistp   word[ebx+4]
;     .end_rot:
	add	ebx,6
	cmp	dword[ebx],-1
	jne	again_r
	ret

    draw_triangles:
      ;  mov     ebp,points_rotated
;  mov esi,triangles
	mov	esi,triangles
    .again_dts:
	mov ebp,points_rotated
      if Ext=NON
	movzx	eax,word[esi]
	lea	eax,[eax*3]
	add	eax,eax
	push	ebp
	add	ebp,eax
	mov	eax,[ebp]
	mov	dword[xx1],eax
	mov	eax,[ebp+4]
	mov	[zz1],ax
	pop	ebp


	movzx	eax,word[esi+2]
	lea	eax,[eax*3]
	add	eax,eax
	push	ebp
	add	ebp,eax
	mov	eax,[ebp]
	mov	dword[xx2],eax
	mov	eax,[ebp+4]
	mov	[zz2],ax
	pop	ebp


	movzx	eax,word[esi+4]        ; xyz3 = [ebp+[esi+4]*6]
	lea	eax,[eax*3]
	add	eax,eax
    ;    push    ebp
	add	ebp,eax
	mov	eax,[ebp]
	mov	dword[xx3],eax
	mov	eax,[ebp+4]
	mov	[zz3],ax
      else
	movq	mm0,[esi]
	pmullw	mm0,qword[const6]
	movd	eax,mm0
	psrlq	mm0,16
	movd	ebx,mm0
	psrlq	mm0,16
	movd	ecx,mm0
	and	eax,0FFFFh
	and	ebx,0FFFFh
	and	ecx,0FFFFh
	movq	mm0,[ebp+eax]
	movq	mm1,[ebp+ebx]
	movq	mm2,[ebp+ecx]
	movq	qword[xx1],mm0
	movq	qword[xx2],mm1
	movq	qword[xx3],mm2
;        emms
      end if
	push esi
;        cmp     [dr_flag],0
;        je      .flat_draw

	xor	edx,edx
	mov	ax,[zz3]
	add	ax,256
	shr	ax,1
	neg	al
	and	ax,0x00ff
	push	ax
	neg	al
	push	ax
       ; mov     dx,[yy3]
       ; and     dx,0x00ff
	push	dx
	mov	ax,[zz2]
	add	ax,256
	shr	ax,1
	neg	al
	and	ax,0x00ff
	push	ax
	neg	al
	push	ax
      ;  mov     dx,[yy2]
      ;  and     dx,0x00ff
	push	dx
	mov	ax,[zz1]
	add	ax,256
	shr	ax,1
	neg	al
	and	ax,0x00ff
	push	ax
	neg	al
	push	ax
      ;  mov     dx,[yy1]
      ;  and     dx,0x00ff
	push	dx
	mov	eax,dword[xx1]
	ror	eax,16
	mov	ebx,dword[xx2]
	ror	ebx,16
	mov	ecx,dword[xx3]
	ror	ecx,16
	mov	edi,screen
	call	gouraud_triangle
;        jmp     .end_draw
;     .flat_draw:
;        mov     ax,[zz1]
;        add     ax,[zz2]
;        add     ax,[zz3]
;        cwd
;        idiv    [i3] ;    = -((a+b+c)/3+130)
;        add     ax,130
;        neg     al
;        xor     edx,edx
;        mov     ah,al           ;set color according to z position
;        shl     eax,8
;        mov     edx,eax

;        mov     eax,dword[xx1]
;        ror     eax,16
;        mov     ebx,dword[xx2]
;        ror     ebx,16
;        mov     ecx,dword[xx3]
;        ror     ecx,16
;        mov     edi,screen
;        call    draw_triangle

;      .end_draw:
	pop	esi
	add	esi,6
	cmp	dword[esi],-1
	jne	.again_dts
	ret

    translate_points:
	fninit
	mov	ebx,points_rotated
    again_trans:
	fild	word[ebx+4] ;z1
	fmul	[sq]
	fld	st
	fiadd	word[ebx]  ;x1
	fistp	word[ebx]
	fchs
	fiadd	word[ebx+2] ;y1
	fistp	word[ebx+2] ;y1

	add	ebx,6
	cmp	dword[ebx],-1
	jne	again_trans
	ret

    copy_points:
	mov	esi,points
	mov	edi,points_rotated
	mov	ecx,points_count*3+2
	rep	movsw
	ret
macro draw_t
{
       draw_triangle:
    ;----------in - eax - x1 shl 16 + y1
    ;------------- -ebx - x2 shl 16 + y2
    ;---------------ecx - x3 shl 16 + y3
    ;---------------edx - color 0x00rrggbb
    ;---------------edi - pointer to screen buffer
    @ch3:
	cmp	ax,bx
	jg	@ch1
    @ch4:			; sort parameters
	cmp	bx,cx
	jg	@ch2
	jle	@chEnd
    @ch1:
	xchg	eax,ebx
	jmp	@ch4
    @ch2:
	xchg	ebx,ecx
	jmp	@ch3
    @chEnd:
	mov	dword[@y1],eax	; ....and store to user friendly  variables
	mov	dword[@y2],ebx
	mov	dword[@y3],ecx
	mov	[@col],edx
	mov	edx,eax 	; eax,ebx,ecx are ORd together into edx which means that
	or	edx,ebx 	; if any *one* of them is negative a sign flag is raised
	or	edx,ecx
	test	edx,80008000h	; Check both X&Y at once
	jne	@end_triangle

	cmp	[@y1],SIZE_Y	; {
	jg	@end_triangle
	cmp	[@y2],SIZE_Y
	jg	@end_triangle
	cmp	[@y3],SIZE_Y
	jg	@end_triangle	; This can be optimized with effort
	cmp	[@x1],SIZE_X
	jg	@end_triangle
	cmp	[@x2],SIZE_X
	jg	@end_triangle
	cmp	[@x3],SIZE_X
	jg	@end_triangle	; }

	shr	eax,16
	shr	ebx,16
	shr	ecx,16

	neg	ax		; calculate delta 12
	add	ax,bx
	cwde
	shl	eax,ROUND
	cdq
	mov	bx,[@y2]
	mov	cx,[@y1]
	sub	bx,cx
	;cmp     ebx,0
	jne	@noZero1
	mov	[@dx12],0
	jmp	@yesZero1
    @noZero1:
	idiv	ebx
	mov	[@dx12],eax
    @yesZero1:

	mov	ax,[@x3]	; calculate delta 13
	sub	ax,[@x1]
	cwde
	shl	eax,ROUND
	cdq
	mov	bx,[@y3]
	mov	cx,[@y1]
	sub	bx,cx
	;cmp     ebx,0
	jne	@noZero2
	mov	[@dx13],0
	jmp	@yesZero2
    @noZero2:
	idiv	ebx
	mov	[@dx13],eax
    @yesZero2:

	mov	ax,[@x3]     ; calculate delta 23 [dx23]
	sub	ax,[@x2]
	cwde
	shl	eax,ROUND
	cdq
	mov	bx,[@y3]
	mov	cx,[@y2]
	sub	bx,cx
	;cmp     ebx,0
	jne	@noZero3
	mov	[@dx23],0
	jmp	@yesZero3
    @noZero3:
	idiv	ebx
	mov	[@dx23],eax
    @yesZero3:

	movzx	eax,word[@x1]	; eax - xk1
	shl	eax,ROUND
	mov	ebx,eax 	; ebx - xk2
	movzx	esi,word[@y1]	; esi - y
    @next_line1:
	mov	ecx,eax 	; ecx - x11
	sar	ecx,ROUND
	mov	edx,ebx 	; edx - x12
	sar	edx,ROUND
	cmp	ecx,edx
	jle	@nochg
	xchg	ecx,edx
    @nochg:
	pusha
	mov	ebx,ecx
	sub	edx,ecx
	mov	ecx,edx
	mov	edx,esi
	mov	eax,[@col]
	call	@horizontal_line
	popa
	add	eax,[@dx13]
	add	ebx,[@dx12]
	inc	esi
	cmp	si,[@y2]
	jl	@next_line1

	movzx	esi,word[@y2]
	movzx	ebx,word[@x2]
	shl	ebx,ROUND
    @next_line2:
	mov	ecx,eax
	sar	ecx,ROUND
	mov	edx,ebx
	sar	edx,ROUND
	cmp	ecx,edx
	jle	@nochg1
	xchg	ecx,edx
    @nochg1:
	pusha
	mov	ebx,ecx
	sub	edx,ecx
	mov	ecx,edx
	mov	edx,esi
	mov	eax,[@col]
	call	@horizontal_line
	popa
	add	eax,[@dx13]
	add	ebx,[@dx23]
	inc	esi
	cmp	si,[@y3]
	jl	@next_line2
    @end_triangle:
	ret

    @horizontal_line:
    ;---------in
    ;---------eax - color of line,  0x00RRGGBB
    ;---------ebx - x1 - x position of line begin
    ;---------ecx - lenght of line
    ;---------edx - y position of line
    ;---------edi - pointer to buffer
	jcxz	@end_hor_l
	push	eax
	mov	eax,SIZE_X*3
	mul	edx
	add	edi,eax 	; calculate line begin adress
	;add     edi,ebx
	;shl     ebx,1
	lea	edi,[edi+ebx*2]
	add	edi,ebx
	pop	eax
	cld
	;mov dword[edi-3],0000FF00h
    @ddraw:			; Drawing horizontally:
	;push    eax
	stosd			; 4 bytes at a time
	dec edi 		; point to the 4th
	;shr     eax,16
	;stosb
	;pop     eax
	;pusha                    ; If you want to draw pixel-by-pixel
	;    mov  eax,7           ; put image
	;    mov  ebx,screen
	;    mov  ecx,SIZE_X shl 16 + SIZE_Y
	;    mov  edx,5 shl 16 + 20
	;    int  0x40
	;popa
	loop	@ddraw
	mov	byte[edi],0	; The last 4th will be reset
    @end_hor_l:
	ret
}
    gouraud_triangle:
;------------------in - eax - x1 shl 16 + y1 ---------
;---------------------- ebx - x2 shl 16 + y2 ---------
;---------------------- ecx - x3 shl 16 + y3 ---------
;---------------------- edi - pointer to screen buffer
;---------------------- stack : colors----------------
;----------------- procedure don't save registers !!--
.col1r equ ebp+4	     ; each color as word
.col1g equ ebp+6
.col1b equ ebp+8
.col2r equ ebp+10
.col2g equ ebp+12
.col2b equ ebp+14
.col3r equ ebp+16
.col3g equ ebp+18
.col3b equ ebp+20

.x1    equ word[ebp-2]
.y1    equ word[ebp-4]
.x2    equ word[ebp-6]
.y2    equ word[ebp-8]
.x3    equ word[ebp-10]
.y3    equ word[ebp-12]

.dc12r equ dword[ebp-16]
.dc12g equ dword[ebp-20]
.dc12b equ dword[ebp-24]
.dc13r equ dword[ebp-28]
.dc13g equ dword[ebp-32]
.dc13b equ dword[ebp-36]
.dc23r equ dword[ebp-40]
.dc23g equ dword[ebp-44]
.dc23b equ dword[ebp-48]

.c1r   equ dword[ebp-52]
.c1g   equ dword[ebp-56]
.c1b   equ dword[ebp-60]
.c2r   equ dword[ebp-64]
.c2g   equ dword[ebp-68]
.c2b   equ dword[ebp-72]

.dx12  equ dword[ebp-76]
.dx13  equ dword[ebp-80]
.dx23  equ dword[ebp-84]



       mov ebp,esp
;       sub esp,72

 .sort3:		  ; sort triangle coordinates...
       cmp ax,bx
       jle .sort1
       xchg eax,ebx
       mov edx,dword[.col1r]
       xchg edx,dword[.col2r]
       mov dword[.col1r],edx
       mov dx,word[.col1b]
       xchg dx,word[.col2b]
       mov word[.col1b],dx
 .sort1:
       cmp bx,cx
       jle .sort2
       xchg ebx,ecx
       mov edx,dword[.col2r]
       xchg edx,dword[.col3r]
       mov dword[.col2r],edx
       mov dx,word[.col2b]
       xchg dx,word[.col3b]
       mov word[.col2b],dx
       jmp .sort3
 .sort2:
       push eax   ;store triangle coordinates in user friendly variables
       push ebx
       push ecx
       sub esp,72 ; set correctly value of esp

       mov edx,eax    ; check only X triangle coordinate
       or edx,ebx
       or edx,ecx
       test edx,80000000h
       jne .gt_loop2_end
       shr eax,16
       cmp ax,SIZE_X-1
       jg .gt_loop2_end
       shr ebx,16
       cmp bx,SIZE_X-1
       jg .gt_loop2_end
       shr ecx,16
       cmp cx,SIZE_X-1
       jg .gt_loop2_end


       mov bx,.y2	; calc deltas
       sub bx,.y1
       jnz .gt_dx12_make
       mov .dx12,0
       mov .dc12r,0
       mov .dc12g,0
       mov .dc12b,0
       jmp .gt_dx12_done
  .gt_dx12_make:

       mov ax,.x2
       sub ax,.x1
       cwde
       movsx ebx,bx
       shl eax,ROUND
       cdq
       idiv ebx
       mov .dx12,eax

       mov ax,word[.col2r]
       sub ax,word[.col1r]
       cwde
       shl eax,ROUND
       cdq
       idiv ebx
       mov .dc12r,eax
       mov ax,word[.col2g]
       sub ax,word[.col1g]
       cwde
       shl eax,ROUND
       cdq
       idiv ebx
       mov .dc12g,eax
       mov ax,word[.col2b]
       sub ax,word[.col1b]
       cwde
       shl eax,ROUND
       cdq
       idiv ebx
       mov .dc12b,eax
.gt_dx12_done:

       mov bx,.y3
       sub bx,.y1
       jnz .gt_dx13_make
       mov .dx13,0
       mov .dc13r,0
       mov .dc13g,0
       mov .dc13b,0
       jmp .gt_dx13_done
.gt_dx13_make:
       mov ax,.x3
       sub ax,.x1
       cwde
       movsx ebx,bx
       shl eax,ROUND
       cdq
       idiv ebx
       mov .dx13,eax

       mov ax,word[.col3r]
       sub ax,word[.col1r]
       cwde
       shl eax,ROUND
       cdq
       idiv ebx
       mov .dc13r,eax
       mov ax,word[.col3g]
       sub ax,word[.col1g]
       cwde
       shl eax,ROUND
       cdq
       idiv ebx
       mov .dc13g,eax
       mov ax,word[.col3b]
       sub ax,word[.col1b]
       cwde
       shl eax,ROUND
       cdq
       idiv ebx
       mov .dc13b,eax
.gt_dx13_done:

       mov bx,.y3
       sub bx,.y2
       jnz .gt_dx23_make
       mov .dx23,0
       mov .dc23r,0
       mov .dc23g,0
       mov .dc23b,0
       jmp .gt_dx23_done
.gt_dx23_make:
       mov ax,.x3
       sub ax,.x2
       cwde
       movsx ebx,bx
       shl eax,ROUND
       cdq
       idiv ebx
       mov .dx23,eax

       mov ax,word[.col3r]
       sub ax,word[.col2r]
       cwde
       shl eax,ROUND
       cdq
       idiv ebx
       mov .dc23r,eax
       mov ax,word[.col3g]
       sub ax,word[.col2g]
       cwde
       shl eax,ROUND
       cdq
       idiv ebx
       mov .dc23g,eax
       mov ax,word[.col3b]
       sub ax,word[.col2b]
       cwde
       shl eax,ROUND
       cdq
       idiv ebx
       mov .dc23b,eax
.gt_dx23_done:

       movsx eax,.x1
       shl eax,ROUND
       mov ebx,eax
       movsx edx,word[.col1r]
       shl edx,ROUND
       mov .c1r,edx
       mov .c2r,edx
       movsx edx,word[.col1g]
       shl edx,ROUND
       mov .c1g,edx
       mov .c2g,edx
       movsx edx,word[.col1b]
       shl edx,ROUND
       mov .c1b,edx
       mov .c2b,edx
       mov cx,.y1
       cmp cx,.y2
       jge .gt_loop1_end
.gt_loop1:
       push eax 		      ; eax - cur x1
       push ebx 		      ; ebx - cur x2
       push cx			      ; cx  - cur y
       push edi
       push ebp

       mov edx,.c2r		 ; c2r,c2g,c2b,c1r,c1g,c1b - current colors
       sar edx,ROUND
       push dx
       mov edx,.c2g
       sar edx,ROUND
       push dx
       mov edx,.c2b
       sar edx,ROUND
       push dx
       mov edx,.c1r
       sar edx,ROUND
       push dx
       mov edx,.c1g
       sar edx,ROUND
       push dx
       mov edx,.c1b
       sar edx,ROUND
       push dx
       push cx
       sar ebx,ROUND
       push bx
       sar eax,ROUND
       push ax
       call gouraud_line

       pop ebp
       pop edi
       pop cx
       pop ebx
       pop eax

       mov edx,.dc13r
       add .c1r,edx
       mov edx,.dc13g
       add .c1g,edx
       mov edx,.dc13b
       add .c1b,edx
       mov edx,.dc12r
       add .c2r,edx
       mov edx,.dc12g
       add .c2g,edx
       mov edx,.dc12b
       add .c2b,edx

       add eax,.dx13
       add ebx,.dx12
       inc cx
       cmp cx,.y2
       jl .gt_loop1
.gt_loop1_end:

       mov cx,.y2
       cmp cx,.y3
       jge .gt_loop2_end
       movsx ebx,.x2
       shl ebx,ROUND

       movsx edx,word[.col2r]
       shl edx,ROUND
       mov .c2r,edx
       movsx edx,word[.col2g]
       shl edx,ROUND
       mov .c2g,edx
       movsx edx,word[.col2b]
       shl edx,ROUND
       mov .c2b,edx
.gt_loop2:
       push eax 		      ; eax - cur x1
       push ebx 		      ; ebx - cur x2
       push cx
       push edi
       push ebp

       mov edx,.c2r
       sar edx,ROUND
       push dx
       mov edx,.c2g
       sar edx,ROUND
       push dx
       mov edx,.c2b
       sar edx,ROUND
       push dx
       mov edx,.c1r
       sar edx,ROUND
       push dx
       mov edx,.c1g
       sar edx,ROUND
       push dx
       mov edx,.c1b
       sar edx,ROUND
       push dx
       push cx
       sar ebx,ROUND
       push bx
       sar eax,ROUND
       push ax
       call gouraud_line

       pop ebp
       pop edi
       pop cx
       pop ebx
       pop eax

       mov edx,.dc13r
       add .c1r,edx
       mov edx,.dc13g
       add .c1g,edx
       mov edx,.dc13b
       add .c1b,edx
       mov edx,.dc23r
       add .c2r,edx
       mov edx,.dc23g
       add .c2g,edx
       mov edx,.dc23b
       add .c2b,edx

       add eax,.dx13
       add ebx,.dx23
       inc cx
       cmp cx,.y3
       jl .gt_loop2
.gt_loop2_end:

      ; add esp,84
      mov esp,ebp
ret 18
gouraud_line:
;-------------in - edi - pointer to screen buffer
;----------------- stack - another parameters
.x1 equ word [ebp+4]
.x2 equ word [ebp+6]
.y equ word [ebp+8]
.col1b equ ebp+10
.col1g equ ebp+12
.col1r equ ebp+14
.col2b equ ebp+16
.col2g equ ebp+18
.col2r equ ebp+20
.dc_r equ dword[ebp-4]
.dc_g equ dword[ebp-8]
.dc_b equ dword[ebp-12]
       mov ebp,esp

       mov ax,.y
       or ax,ax
       jl .gl_quit
       cmp ax,SIZE_Y-1
       jg .gl_quit

       mov ax,.x1
       cmp ax,.x2
       je .gl_quit
       jl .gl_ok

       xchg ax,.x2
       mov .x1,ax
       mov eax,dword[.col1b]
       xchg eax,dword[.col2b]
       mov  dword[.col1b],eax
       mov ax,word[.col1r]
       xchg ax,word[.col2r]
       mov word[.col1r],ax
.gl_ok:
       movsx ecx,.y
       mov eax,SIZE_X*3
       mul ecx
       movsx ebx,.x1
       lea ecx,[ebx*2+eax]
       add edi,ecx
       add edi,ebx

       mov ax,word[.col2r]
       sub ax,word[.col1r]
       cwde
       shl eax,ROUND
       cdq
       mov cx,.x2
       sub cx,.x1
       movsx ecx,cx
       idiv ecx
       ;mov .dc_r,eax           ;first delta
       push eax

       mov ax,word[.col2g]
       sub ax,word[.col1g]
       cwde
       shl eax,ROUND
       cdq
       idiv ecx
       ;mov .dc_g,eax
       push eax

       mov ax,word[.col2b]
       sub ax,word[.col1b]
       cwde
       shl eax,ROUND
       cdq
       idiv ecx
      ; mov .dc_b,eax
       push eax

       movsx ebx,word[.col1r]
       shl ebx,ROUND
       movsx edx,word[.col1g]
       shl edx,ROUND
       movsx esi,word[.col1b]
       shl esi,ROUND
.gl_draw:
       mov eax,ebx
       sar eax,ROUND
       stosb
       mov eax,edx
       sar eax,ROUND
       stosb
       mov eax,esi
       sar eax,ROUND
       stosb
       add ebx,.dc_r
       add edx,.dc_g
       add esi,.dc_b
       loop .gl_draw
.gl_quit:
      ; add esp,12
       mov esp,ebp
ret 18


macro read
{
    read_from_file:
	mov	edi,triangles
	xor	ebx,ebx
	xor	ebp,ebp
	mov	esi,SourceFile
	cmp	[esi],word 4D4Dh
	jne	.exit ;Must be legal .3DS file
	cmp	dword[esi+2],EndFile-SourceFile
	jne	.exit ;This must tell the length
	add	esi,6
      @@:
	cmp	[esi],word 3D3Dh
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	add	esi,6
      .find4k:
	cmp	[esi],word 4000h
	je	@f
	add	esi,[esi+2]
	cmp	esi,EndFile
	jc	.find4k
	jmp	.exit
      @@:
	add	esi,6
      @@:
	cmp	[esi],byte 0
	je	@f
	inc	esi
	jmp	@b
      @@:
	inc	esi
      @@:
	cmp	[esi],word 4100h
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	add	esi,6
      @@:
	cmp	[esi],word 4110h
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	movzx	ecx,word[esi+6]
	mov	edx,ecx
	add	esi,8
      @@:
	fld	dword[esi+4]
	fadd	[xoffset]
	fld	dword[esi+8]
	fchs
	fadd	[yoffset]
	fld	dword[esi+0]
	fchs
	fistp	word[points+ebx+4]
	fistp	word[points+ebx+2]
	fistp	word[points+ebx+0]
	add	ebx,6
	add	esi,12
	dec	ecx
	jnz	@b
      @@:
	mov	dword[points+ebx],-1
      @@:
	cmp	[esi],word 4120h
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	movzx	ecx,word[esi+6]
	add	esi,8
	;mov     edi,triangles
      @@:
	movsd
	movsw
	add	word[edi-6],bp
	add	word[edi-4],bp
	add	word[edi-2],bp
	add	esi,2
	dec	ecx
	jnz	@b
	add	ebp,edx
	jmp	.find4k

      .exit:
	mov	dword[edi],-1
	ret

}
;   *********************************************
;   *******  WINDOW DEFINITIONS AND DRAW ********
;   *********************************************
    draw_window:
	mov	eax,12		; function 12:tell os about windowdraw
	mov	ebx,1		; 1, start of draw
	int	0x40

	; DRAW WINDOW
	mov	eax,0		; function 0 : define and draw window
	mov	ebx,100*65536+SIZE_X+20 ; [x start] *65536 + [x size]
	mov	ecx,100*65536+SIZE_Y+30 ; [y start] *65536 + [y size]
	mov	edx,0x02000000	; color of work area RRGGBB,8->color gl
	mov	esi,0x805080d0	; color of grab bar  RRGGBB,8->color gl
	mov	edi,0x005080d0	; color of frames    RRGGBB
	int	0x40

	; WINDOW LABEL
	mov	eax,4		; function 4 : write text to window
	mov	ebx,8*65536+8	; [x start] *65536 + [y start]
	mov	ecx,0x20ddeeff	; font 1 & color ( 0xF0RRGGBB )
	mov	edx,labelt	; pointer to text beginning
	mov	esi,labellen-labelt	; text length
	int	0x40

	; CLOSE BUTTON
	mov	eax,8		; function 8 : define and draw button
	mov	ebx,(SIZE_X+20-19)*65536+12	; [x start] *65536 + [x size]
	mov	ecx,5*65536+12	; [y start] *65536 + [y size]
	mov	edx,1		; button id
	mov	esi,0x6688dd	; button color RRGGBB
	int	0x40

	 ; ROTARY BUTTON
;        mov     eax,8           ; function 8 : define and draw button
;        mov     ebx,(SIZE_X-19)*65536+12     ; [x start] *65536 + [x size]
;        mov     ecx,5*65536+12  ; [y start] *65536 + [y size]
;        mov     edx,2           ; button id
;        mov     esi,0x6688dd    ; button color RRGGBB
;        int     0x40
;        mov     eax,12          ; function 12:tell os about windowdraw
;        mov     ebx,2           ; 2, end of draw
;        int     0x40
	 ; DRAW BUTTON
;        mov     eax,8           ; function 8 : define and draw button
;        mov     ebx,(SIZE_X-2*19)*65536+12     ; [x start] *65536 + [x size]
;        mov     ecx,5*65536+12  ; [y start] *65536 + [y size]
;        mov     edx,3           ; button id
;        mov     esi,0x6688dd    ; button color RRGGBB
;        int     0x40
	 ; SPEED BUTTON
;        mov     eax,8           ; function 8 : define and draw button
;        mov     ebx,(SIZE_X-3*19)*65536+12     ; [x start] *65536 + [x size]
;        mov     ecx,5*65536+12  ; [y start] *65536 + [y size]
;        mov     edx,4           ; button id
;        mov     esi,0x6688dd    ; button color RRGGBB
;        int     0x40

	mov	eax,12		; function 12:tell os about windowdraw
	mov	ebx,2		; 2, end of draw
	int	0x40

	ret


	; DATA AREA
	i3		dw	3
	sort_flag	db	0
	tr_counter	dw	0

	angle_counter dw 0
	piD180	   dd 0.017453292519943295769236907684886
	sq	   dd 0.70710678118654752440084436210485
	const6	   dw 6,6,6,6
	xo	   dw 212
	zo	   dw 0
	yo	   dw 100
	xoffset    dd 130.0
	yoffset    dd 100.0
;        r_flag     db 0
;        dr_flag    db 1
;        speed_flag db 0

;    SourceFile file 'House.3ds'
;    EndFile:

    labelt:
	db   'SANCTISSIMI CORDIS CHRISTI MISERERE NOBIS'
      if Ext=MMX
	db   ' (MMX)'
      end if
    labellen:
	STRdata db '-1        '
align 8
;        @col    dd      ?
;        @y1     dw      ?
;        @x1     dw      ?;+8
;        @y2     dw      ?
;        @x2     dw      ?
;        @y3     dw      ?
;        @x3     dw      ?;+16

;        @dx12   dd      ?
;        @dx13   dd      ?;+24
;        @dx23   dd      ?

	sinbeta dd	?;+32
	cosbeta dd	?

	xsub	dw	?
	zsub	dw	?;+40
	ysub	dw	?

	xx1	dw	?
	yy1	dw	?
	zz1	dw	?;+48
	xx2	dw	?
	yy2	dw	?
	zz2	dw	?
	xx3	dw	?;+56
	yy3	dw	?
	zz3	dw	?

	high	dd	?
align 8
	buffer	dq	?

	err	dd	?
	drr	dd	?
	xx	dd	?
	yy	dd	?
	xst	dd	?
	yst	dd	?
align 16
    points:
;cordis
dw 125,175,0, 175,175,0, 212,212,0, 250,175,0, 300,175,0, 325,200,0, 325,250,0
dw 300,300,0, 212,350,0, 125,300,0, 100,250,0, 100,200,0,175,250,-20,250,250,-20
;crux
dw 175,125,0, 200,125,0, 200,100,0, 225,100,0, 225,125,0, 250,125,0, 250,150,0
dw 225,150,0, 225,200,0, 200,200,0, 200,150,0, 175,150,0
;cordis next layer
dw 125,175,20, 175,175,20, 212,212,20, 250,175,20, 300,175,20, 325,200,20
dw 325,250,20, 300,300,20, 212,350,20, 125,300,20, 100,250,20, 100,200,20
dw 175,250,40, 250,250,40
;crux
dw 175,125,20, 200,125,20, 200,100,20, 225,100,20, 225,125,20, 250,125,20
dw 250,150,20, 225,150,20, 225,200,20, 200,200,20, 200,150,20, 175,150,20
;crown
dw 50,250,-25, 50,250,25, 100,250,75, 175,250,100,  275,250,100, 350,250,75
dw 380,250,25, 380,250,-25,350,250,-75,275,250,-100,175,250,-100, 100,250,-75
dw 50,265,-25, 100,265,75, 275,265,100,380,265,25,  350,265,-75, 175,265,-100
;thorns
dw 50,250,-50, 75,260,103, 275,240,150, 365,250,25, 350,260,-41, 150,240,-125

	points_count = ($-points)/6
dd -1
    triangles:
dw 0,1,12, 1,2,12, 8,9,12, 9,10,12, 10,11,12, 11,0,12, 12,13,2, 12,13,8, 2,3,13
dw 3,4,13, 4,5,13, 5,6,13, 6,7,13, 7,8,13
;crux
dw 21,22,23, 23,24,21, 24,25,14, 24,14,18, 24,18,20, 18,19,20, 15,16,18
dw 16,17,18
;cordis next layer
dw 26,27,38, 27,28,38, 34,35,38, 35,36,38, 36,37,38,37,26,38,38,39,34,28,29,39
dw 29,30,39, 30,31,39, 31,32,39, 32,33,39, 33,34,39, 38,39,28
; crux next layer
dw 47,48,49, 49,50,47, 50,51,40, 50,40,44, 50,42,44
dw 42,43,44, 46,50,44, 44,45,46
;border cordis
dw 0,1,26, 26,27,1, 1,2,27, 27,28,2, 2,3,28, 28,29,3, 3,4,29, 29,30,4, 4,5,30
dw 30,31,5, 5,6,31, 31,32,6, 6,7,32, 32,33,7, 7,8,33, 33,34,8, 8,9,34, 34,35,9
dw 9,10,35, 35,36,10, 10,11,36, 36,37,11, 11,0,37, 37,26,0
;border crux
dw 14,15,40, 40,41,15, 15,16,41, 41,42,16, 16,17,42, 42,43,17, 17,18,43
dw 43,44,18, 18,19,44, 44,45,19, 19,20,45, 45,46,20, 20,21,46, 46,47,21
dw 21,22,47, 47,48,22, 23,24,49, 49,50,24, 24,25,50, 50,51,25, 25,14,51
dw 14,51,40
;crown
dw 52,53,64, 53,54,65, 54,55,65, 55,56,66, 56,57,66, 57,58,67, 58,59,67
dw 59,60,68, 60,61,68, 61,62,69, 62,63,69, 63,64,52
;thorns
dw 52,64,70, 54,65,71, 56,66,72, 58,67,73, 68,60,74, 69,62,75
	triangles_count = ($-triangles)/6
dd -1
align 16
	points_rotated rw points_count*3 + 2
align 16
	label trizdd dword
	label trizdq qword
	triangles_with_z rw triangles_count*4 + 2 ; triangles triple dw + z position
align 16
	sorted_triangles rw triangles_count*3 + 2
align 16
	screen rb SIZE_X * SIZE_Y * 3	; screen buffer
	memStack rb 3000 ;memory area for stack
    I_END: